<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Geeklog 1.3                                                               |
// +---------------------------------------------------------------------------+
// | digesting.php                                                             |
// | Reset a user's Daily Digest settings to "no topics". This is useful e.g.  |
// | when the user's email address bounces ...                                 |
// |                                                                           |
// | Installation: Put this script into your Geeklog admin directory.          |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2003 by the following authors:                              |
// |                                                                           |
// | Authors: Dirk Haun        - dirk@haun-online.de                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
// 
// $Id$

require_once ('../lib-common.php');


// Make sure user has access to this page
if (!SEC_hasRights('user.edit')) {
    $retval .= COM_siteHeader('menu');
    $retval .= COM_startBlock($MESSAGE[30]);
    $retval .= $MESSAGE[37];
    $retval .= COM_endBlock();
    $retval .= COM_siteFooter();
    COM_errorLog("User {$_USER['username']} tried to illegally access the digest administration screen",1);
    echo $retval;
    exit;
}

// +---------------------------------------------------------------------------+
// | Text strings used by this script (in German and English)                  |
// +---------------------------------------------------------------------------+

if ($_CONF['language'] == 'german')
{
    $LANG_DIGEST = array(
        search_text => 'Hier kannst Du nach Usernamen, E-Mail-Adressen oder User-IDs suchen.',
        search_button => 'Suchen',
        new_search => 'Neue Suche',
        inspect_text => 'Auf den Usernamen klicken, um die Daily Digest-Einstellungen zu berprfen.',
        uid_not_found => 'Es gibt keinen User mit ID %d.',
        not_found => 'Deine Suche nach <b>%s</b> lieferte keine Resultate.',
        try_again => 'Bitte noch einmal versuchen.',
        user => 'User',
        topics => 'Kategorien',
        all_topics => 'alle Kategorien',
        no_topics => 'keine',
        reset_button => 'zurcksetzen',
        success => 'Die Daily Digest-Einstellungen fr <b>%s</b> wurden zurckgesetzt.',
        block_headline => 'Daily Digest Maintenance'
    );
}
else // default to English
{
    $LANG_DIGEST = array(
        search_text => 'Search for a user name, email address or user id.',
        search_button => 'Search',
        new_search => 'New Search',
        inspect_text => "Click on the user name to inspect the user's daily digest settings.",
        uid_not_found => 'There is no user account with user id %d.',
        not_found => 'There were no matches for <b>%s</b>.',
        try_again => 'Please try again.',
        user => 'User',
        topics => 'Topics',
        all_topics => 'all topics',
        no_topics => 'none',
        reset_button => 'Reset',
        success => 'Daily Digest settings for user <b>%s</b> have been reset.',
        block_headline => 'Daily Digest Maintenance'
    );
}


function display_form ($query = '')
{
    global $LANG_DIGEST, $PHP_SELF;

    $display = '';

    $display .= '<form action="' . $PHP_SELF . '" method="GET">' . LB;
    $display .= '<p>' . $LANG_DIGEST['search_text'] . '</p>' . LB;
    $display .= '<input type="text" size="40" name="query" value="' . $query . '">' . LB;
    $display .= '<input type="submit" value="' . $LANG_DIGEST['search_button'] . '">' . LB;
    $display .= '<input type="hidden" name="mode" value="search">' . LB;
    $display .= '</form>' . LB;

    return $display;
}

function search_user ($query)
{
    global $_TABLES, $_CONF, $LANG28, $LANG_DIGEST, $PHP_SELF;

    $retval = '';

    if (empty ($query)) {
        $retval .= display_form ();
    } else {
        $retval .= '[ <a href="' . $PHP_SELF . '">' . $LANG_DIGEST['new_search'] . '</a> | <a href="' . $_CONF['site_admin_url'] . '">' . $LANG28[16] . '</a> ]</p>' . LB;

        if (is_numeric ($query)) {
            $sql = "SELECT uid,username,fullname,email FROM {$_TABLES['users']} WHERE uid = '{$query}'";
        } else {
            $sql = "SELECT uid,username,fullname,email FROM {$_TABLES['users']} WHERE username LIKE '%{$query}%' OR fullname LIKE '%{$query}%' OR email LIKE '%{$query}%' ORDER BY uid";
        }

        $result = DB_query ($sql);
        $num = DB_numRows ($result);
        if ($num > 0) {
            $retval .= '<p>' . $LANG_DIGEST['inspect_text'] . '</p>' . LB;
            $retval .= '<table width="100%" border="0">' . LB;
            $retval .= '<tr><th colspan="2" align="left">' . $LANG28[3] . '</th><th align="left">' . $LANG28[4] . '</th><th align="left">' . $LANG28[7] . '</th></tr>' . LB;
            for ($i = 0; $i < $num; $i++) {
                $A = DB_fetchArray ($result);
                $retval .= '<tr>';
                $retval .= '<td><a href="' . $_CONF['site_url'] . '/users.php?mode=profile&amp;uid=' . $A['uid'] . '"><img src="' . $_CONF['layout_url'] . '/images/person.gif" border="0"></a></td>';
                $retval .= '<td><a href="' . $PHP_SELF . '?mode=inspect&amp;uid=' . $A['uid'] . '">' . $A['username'] . '</a></td>';
                $retval .= '<td>' . $A['fullname'] . '</td>';
                $retval .= '<td><a href="mailto:' . $A['email'] . '">' . $A['email'] . '</a></td>';
                $retval .= '</tr>' . LB;
            }
            $retval .= '</table>' . LB;
        } else {
            if (is_numeric ($query)) {
                $retval .= '<p>' . sprintf ($LANG_DIGEST['uid_not_found'], $query);
            } else {
                $retval .= '<p>' . sprintf ($LANG_DIGEST['not_found'], $query);
            }
            $retval .= ' ' . $LANG_DIGEST['try_again'] . '</p>' . LB;
            $retval .= display_form ($query);
        }
    }

    return $retval;
}

function inspect ($uid)
{
    global $_TABLES, $_CONF, $LANG28, $LANG_DIGEST, $PHP_SELF;

    $retval = '';

    if ($uid > 1) {
        $result = DB_query ("SELECT username,fullname,email FROM {$_TABLES['users']} WHERE uid = '{$uid}'");
        $U = DB_fetchArray ($result);

        $digest = DB_getItem ($_TABLES['userindex'], 'etids', "uid = '{$uid}'");

        $retval .= '[ <a href="' . $PHP_SELF . '">' . $LANG_DIGEST['new_search'] . '</a> | <a href="' . $_CONF['site_admin_url'] . '">' . $LANG28[16] . '</a> ]</p>' . LB;
        $retval .= '<p>' . $LANG_DIGEST['user'] . ': <b>' . $U['username'] . '</b> ';
        if (!empty ($U['fullname'])) {
            $retval .= '(' . $U['fullname'] . ') ';
        }
        $retval .= '&lt;<a href="mailto:' . $U['email'] . '">' . $U['email'] . '</a>&gt;</p>' . LB;
        $retval .= '<p>' . $LANG_DIGEST['topics'] . ': ';
        if (empty ($digest)) {
            $retval .= '<em>' . $LANG_DIGEST['all_topics'] . '</em>';
        } else if ($digest == '-') {
            $retval .= '<em>' . $LANG_DIGEST['no_topics'] . '</em>';
        } else {
            $topics = explode (' ', $digest);
            foreach ($topics as $t) {
                $tname = DB_getItem ($_TABLES['topics'], 'topic', "tid = '{$t}'");
                $retval .= '<a href="' . $_CONF['site_url'] . '/index.php?topic=' . $t . '">' . $tname . '</a>, ';
            }
        }
        $retval .= '</p>';
        if ($digest != '-') {
            $retval .= '<form action="' . $PHP_SELF . '" action="GET">' . LB;
            $retval .= '<input type="submit" value="' . $LANG_DIGEST['reset_button'] . '">' . LB;
            $retval .= '<input type="hidden" name="mode" value="reset">' . LB;
            $retval .= '<input type="hidden" name="uid" value="' . $uid . '">' . LB;
            $retval .= '</form>' . LB;
        }
    } else {
        $retval .= display_form ();
    }

    return $retval;
}

function reset_it ($uid)
{
    global $_TABLES, $LANG_DIGEST;

    $retval = '';

    if ($uid > 1) {
        DB_query ("UPDATE {$_TABLES['userindex']} SET etids = '-' WHERE uid = '{$uid}'");
        $username = DB_getItem ($_TABLES['users'], 'username', "uid = '{$uid}'");
        $retval .= '<p>' . sprintf ($LANG_DIGEST['success'], $username) . '</p>' . LB;
    }

    $retval .= display_form ();

    return $retval;
}

$display = '';
$display .= COM_siteHeader ('menu');
$display .= COM_startBlock ($LANG_DIGEST['block_headline']);

switch ($HTTP_GET_VARS['mode'])
{
    case 'inspect':
        $display .= inspect ($HTTP_GET_VARS['uid']);
        break;
    case 'reset':
        $display .= reset_it ($HTTP_GET_VARS['uid']);
        break;
    case 'search':
        $display .= search_user ($HTTP_GET_VARS['query']);
        break;
    default:
        $display .= display_form ();
        break;
}

$display .= COM_endBlock ();
$display .= COM_siteFooter ();

echo $display;

?>
